import { ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
import { ScrollableDirective } from 'ng-gxscrollable';
import { SelectSource } from '../../stores/select-source';
import { Option } from '../../models/option';
import { SelectOptions } from '../select/select.component';
import { SelectService } from '../../services/select/select.service';
export declare enum OptionsPosition {
    BottomLeft = 0,
    BottomRight = 1,
    TopLeft = 2,
    TopRight = 3,
}
export declare enum KeyboardEventCode {
    Enter = 13,
    Escape = 27,
    ArrowUp = 38,
    ArrowDown = 40,
}
export declare class OptionsComponent implements OnInit, OnDestroy, OnChanges {
    private cd;
    private platformId;
    private selectService;
    input: any;
    source: SelectSource;
    config: SelectOptions;
    optionTemplate: TemplateRef<any>;
    valueSet: EventEmitter<Option>;
    optionChange: EventEmitter<Option>;
    touch: EventEmitter<void>;
    loadedInitialValue: EventEmitter<void>;
    root: ElementRef;
    scrollable: ScrollableDirective;
    scrollableInner: ElementRef;
    optionsPositions: typeof OptionsPosition;
    optionsPosition: OptionsPosition;
    searchQuery: string;
    searchUpdated: Subject<void>;
    options: Option[];
    hoverOption: Option;
    value: any;
    valueInitialSet: boolean;
    valueOption: Option;
    loading: boolean;
    opened: boolean;
    private sourceSubscriptions;
    constructor(cd: ChangeDetectorRef, platformId: Object, selectService: SelectService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    isPlatformServer(): boolean;
    deinitOptions(): void;
    initOptions(): void;
    loadValue(): void;
    loadMore(): void;
    setValue(value: any): void;
    readonly selectedOption: Option;
    toggleOpened(): void;
    readonly styles: {};
    open(): void;
    close(): void;
    calculateOptionsPosition(): OptionsPosition;
    trackByFn(index: any, item: Option): string;
    onScrolled(): void;
    setHoverOption(option: any): void;
    moveHover(up: any): void;
    selectHovered(): void;
    scrollToHovered(): void;
    templateContext(option: Option): {
        value: any;
        name: string;
        image: string;
        data: any;
    };
}
