import { Observable } from 'rxjs';
import { Option } from '../models/option';
export declare abstract class SelectSource {
    private _valueOption;
    private _options;
    private _loading;
    private loadRequested;
    private fetchRequest;
    private loadingValue;
    private loadingValueObs;
    private fetchValueRequest;
    private searchQuery;
    private _loaded;
    valueOption: Option;
    readonly valueOption$: Observable<Option>;
    options: Option[];
    readonly options$: Observable<Option[]>;
    loading: boolean;
    readonly loading$: Observable<boolean>;
    readonly loaded: boolean;
    reset(): void;
    search(search: any): void;
    setSearch(search: any): void;
    loadMore(): void;
    loadValue(value: any): Observable<Option>;
    abstract fetch(searchQuery: string): Observable<Option[]>;
    abstract fetchByValue(value: any): Observable<Option>;
    abstract isFetchAvailable(): boolean;
    abstract resetPagination(): any;
    abstract setStaticOptions(options: Option[]): any;
}
